Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/Makefile.common	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -40,7 +40,9 @@
 	$(USPACEDIR)/srv/bd/rd/rd \
 	$(USPACEDIR)/srv/vfs/vfs
+
 ifeq ($(RDFMT),tmpfs)
 	INIT_TASKS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
 endif
+
 ifeq ($(RDFMT),fat)
 	INIT_TASKS += $(USPACEDIR)/srv/fs/fat/fat
@@ -58,5 +60,20 @@
 	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
 	$(USPACEDIR)/srv/fs/fat/fat \
-	$(USPACEDIR)/srv/taskmon/taskmon
+	$(USPACEDIR)/srv/taskmon/taskmon \
+	$(USPACEDIR)/srv/hw/netif/dp8390/dp8390 \
+	$(USPACEDIR)/srv/net/netif/lo/lo \
+	$(USPACEDIR)/srv/net/il/arp/arp \
+	$(USPACEDIR)/srv/net/il/ip/ip \
+	$(USPACEDIR)/srv/net/tl/icmp/icmp \
+	$(USPACEDIR)/srv/net/tl/udp/udp \
+	$(USPACEDIR)/srv/net/tl/tcp/tcp \
+	$(USPACEDIR)/srv/net/net/net \
+	$(USPACEDIR)/srv/net/netstart/netstart \
+
+ifneq ($(CONFIG_NETIF_NIL_BUNDLE),y)
+	RD_SRVS += \
+		$(USPACEDIR)/srv/net/nil/eth/eth \
+		$(USPACEDIR)/srv/net/nil/nildummy/nildummy
+endif
 
 RD_APPS = \
@@ -66,4 +83,5 @@
 	$(USPACEDIR)/app/klog/klog \
 	$(USPACEDIR)/app/mkfat/mkfat \
+	$(USPACEDIR)/app/sbi/sbi \
 	$(USPACEDIR)/app/redir/redir \
 	$(USPACEDIR)/app/taskdump/taskdump \
@@ -71,4 +89,8 @@
 	$(USPACEDIR)/app/tetris/tetris \
 	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/nettest1/nettest1 \
+	$(USPACEDIR)/app/nettest2/nettest2 \
+	$(USPACEDIR)/app/netecho/netecho \
+	$(USPACEDIR)/app/ping/ping \
 	$(USPACEDIR)/app/ps/ps \
 	$(USPACEDIR)/app/top/top \
@@ -84,52 +106,15 @@
 	$(USPACEDIR)/srv/bd/rd/rd \
 	$(USPACEDIR)/srv/vfs/vfs
+
 ifeq ($(RDFMT),tmpfs)
 	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
 endif
+
 ifeq ($(RDFMT),fat)
 	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
 endif
 
-CFG =
-
-NET_SRVS = \
-	$(USPACEDIR)/srv/net/net/net \
-	$(USPACEDIR)/srv/net/netif/lo/lo \
-	$(USPACEDIR)/srv/net/nil/eth/eth \
-	$(USPACEDIR)/srv/net/nil/nildummy/nildummy \
-	$(USPACEDIR)/srv/net/app/echo/echo
-
-NET_APPS = \
-	$(USPACEDIR)/srv/net/net/start/netstart \
-	$(USPACEDIR)/srv/net/app/ping/ping \
-	$(USPACEDIR)/srv/net/app/nettest1/nettest1 \
-	$(USPACEDIR)/srv/net/app/nettest2/nettest2
-
-ifneq ($(CONFIG_NETWORKING),none)
-	NET_CFG = \
-		$(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/general \
-		$(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/lo
-	
-	ifeq ($(CONFIG_NETIF_DP8390),y)
-		NET_SRVS += $(USPACEDIR)/srv/net/netif/dp8390/dp8390
-		NET_CFG += $(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/ne2k
-	endif
-	
-	ifeq ($(CONFIG_NETWORKING),module)
-		RD_APPS += $(NET_APPS)
-		RD_SRVS += $(NET_SRVS)
-		CFG += $(NET_CFG)
-	endif
-	
-	ifeq ($(CONFIG_NETWORKING),modular)
-		RD_APPS += $(NET_APPS)
-		RD_SRVS += $(NET_SRVS)
-		RD_SRVS += \
-			$(USPACEDIR)/srv/net/il/ip/ip \
-			$(USPACEDIR)/srv/net/il/arp/arp \
-			$(USPACEDIR)/srv/net/tl/udp/udp \
-			$(USPACEDIR)/srv/net/tl/tcp/tcp \
-			$(USPACEDIR)/srv/net/tl/icmp/icmp
-		CFG += $(NET_CFG)
-	endif
-endif
+NET_CFG = \
+	$(USPACEDIR)/srv/net/cfg/general \
+	$(USPACEDIR)/srv/net/cfg/lo \
+	$(USPACEDIR)/srv/net/cfg/ne2k
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/amd64/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -39,5 +39,5 @@
 build: $(BASE)/image.iso
 
-$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito $(KERNELDIR)/kernel.bin $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
+$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	mkdir -p $(TMP)/boot/grub
 	cp arch/$(BARCH)/grub/stage2_eltorito $(TMP)/boot/grub/
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/arm32/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/arm32/loader/main.c
===================================================================
--- boot/arch/arm32/loader/main.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/arm32/loader/main.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -48,5 +48,5 @@
 
 /** Kernel entry point address. */
-#define KERNEL_VIRTUAL_ADDRESS 0x80200000
+#define KERNEL_VIRTUAL_ADDRESS 0x80800000
 
 
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/ia64/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/mips32/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/ppc32/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -41,5 +41,5 @@
 	mkisofs -hfs -part -map arch/$(BARCH)/yaboot/maps -no-desktop -hfs-volid "HelenOS" -hfs-bless $(TMP)/boot -r -o $@ $(TMP)/
 
-arch/$(BARCH)/loader/image.boot:
+arch/$(BARCH)/loader/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 
Index: boot/arch/ppc32/loader/asm.h
===================================================================
--- boot/arch/ppc32/loader/asm.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/ppc32/loader/asm.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -33,5 +33,5 @@
 #define PAGE_SIZE   (1 << PAGE_WIDTH)
 
-#define TRANS_SIZE   1024
+#define TRANS_SIZE   2048
 #define BOOT_OFFSET  0x8000
 
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ boot/arch/sparc64/Makefile.inc	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -54,5 +54,5 @@
 	mkisofs -f -G $(TMP)/boot/isofs.b -B ... -r -o $@ $(TMP)/
 
-arch/$(BARCH)/loader/image.boot:
+arch/$(BARCH)/loader/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/Makefile	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -283,6 +283,5 @@
 		test/print/print3.c \
 		test/print/print4.c \
-		test/thread/thread1.c \
-		test/sysinfo/sysinfo1.c
+		test/thread/thread1.c
 	
 	ifeq ($(KARCH),mips32)
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/arch/amd64/src/amd64.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -228,9 +228,10 @@
 	    (uintptr_t) I8042_BASE);
 #endif
-
-#ifdef CONFIG_NETIF_DP8390
+	
+	/*
+	 * This nasty hack should also go away ASAP.
+	 */
 	trap_virtual_enable_irqs(1 << IRQ_DP8390);
 	sysinfo_set_item_val("netif.dp8390.inr", NULL, IRQ_DP8390);
-#endif
 }
 
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/arch/arm32/_link.ld.in	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -7,5 +7,5 @@
  */
 
-#define KERNEL_LOAD_ADDRESS 0x80200000
+#define KERNEL_LOAD_ADDRESS 0x80800000
 
 OUTPUT_ARCH(arm)
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/arch/ia32/src/ia32.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -186,9 +186,10 @@
 	    (uintptr_t) I8042_BASE);
 #endif
-
-#ifdef CONFIG_NETIF_DP8390
+	
+	/*
+	 * This nasty hack should also go away ASAP.
+	 */
 	trap_virtual_enable_irqs(1 << IRQ_DP8390);
 	sysinfo_set_item_val("netif.dp8390.inr", NULL, IRQ_DP8390);
-#endif
 }
 
Index: kernel/arch/ia64/src/ia64.c
===================================================================
--- kernel/arch/ia64/src/ia64.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/arch/ia64/src/ia64.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -213,7 +213,5 @@
 #endif
 
-#ifdef CONFIG_NETIF_DP8390
 	sysinfo_set_item_val("netif.dp8390.inr", NULL, IRQ_DP8390);
-#endif
 
 	sysinfo_set_item_val("ia64_iospace", NULL, true);
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -54,4 +54,5 @@
 #include <arch/smp/sun4v/smp.h>
 #include <str.h>
+#include <errno.h>
 
 /** hypervisor code of the "running" state of the CPU */
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/include/ipc/sysipc.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -57,5 +57,5 @@
 unative_t sys_ipc_forward_slow(unative_t callid, unative_t phoneid,
     ipc_data_t *data, int mode);
-unative_t sys_ipc_hangup(int phoneid);
+unative_t sys_ipc_hangup(unative_t phoneid);
 unative_t sys_ipc_register_irq(inr_t inr, devno_t devno, unative_t method,
     irq_code_t *ucode);
Index: kernel/generic/include/str.h
===================================================================
--- kernel/generic/include/str.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/include/str.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -89,4 +89,7 @@
 extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
 
+extern char *str_dup(const char *src);
+extern char *str_ndup(const char *src, size_t n);
+
 extern char *str_chr(const char *str, wchar_t ch);
 
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/include/syscall/syscall.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -82,6 +82,8 @@
 	SYS_PREEMPT_CONTROL,
 	
-	SYS_SYSINFO_VALID,
-	SYS_SYSINFO_VALUE,
+	SYS_SYSINFO_GET_TAG,
+	SYS_SYSINFO_GET_VALUE,
+	SYS_SYSINFO_GET_DATA_SIZE,
+	SYS_SYSINFO_GET_DATA,
 	
 	SYS_DEBUG_ENABLE_CONSOLE,
Index: kernel/generic/include/sysinfo/sysinfo.h
===================================================================
--- kernel/generic/include/sysinfo/sysinfo.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/include/sysinfo/sysinfo.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -41,51 +41,79 @@
 extern bool fb_exported;
 
-typedef union sysinfo_item_val {
+typedef enum {
+	SYSINFO_VAL_UNDEFINED = 0,
+	SYSINFO_VAL_VAL = 1,
+	SYSINFO_VAL_DATA = 2,
+	SYSINFO_VAL_FUNCTION_VAL = 3,
+	SYSINFO_VAL_FUNCTION_DATA = 4
+} sysinfo_item_val_type_t;
+
+typedef enum {
+	SYSINFO_SUBTREE_NONE = 0,
+	SYSINFO_SUBTREE_TABLE = 1,
+	SYSINFO_SUBTREE_FUNCTION = 2
+} sysinfo_subtree_type_t;
+
+struct sysinfo_item;
+
+typedef unative_t (*sysinfo_fn_val_t)(struct sysinfo_item *);
+typedef void *(*sysinfo_fn_data_t)(struct sysinfo_item *, size_t *);
+typedef struct sysinfo_item *(*sysinfo_fn_subtree_t)(const char *);
+
+typedef struct {
+	void *data;
+	size_t size;
+} sysinfo_data_t;
+
+typedef union {
 	unative_t val;
-	void *fn; 
+	sysinfo_fn_val_t fn_val;
+	sysinfo_fn_data_t fn_data;
+	sysinfo_data_t data;
 } sysinfo_item_val_t;
+
+typedef union {
+	struct sysinfo_item *table;
+	sysinfo_fn_subtree_t find_item;
+} sysinfo_subtree_t;
 
 typedef struct sysinfo_item {
 	char *name;
+	
+	sysinfo_item_val_type_t val_type;
+	sysinfo_item_val_t val;
+	
+	sysinfo_subtree_type_t subtree_type;
+	sysinfo_subtree_t subtree;
+	
+	struct sysinfo_item *next;
+} sysinfo_item_t;
+
+typedef struct {
+	sysinfo_item_val_type_t tag;
 	union {
 		unative_t val;
-		void *fn; 
-	} val;
+		sysinfo_data_t data;
+	};
+} sysinfo_return_t;
 
-	union {
-		struct sysinfo_item *table;
-		void *fn;
-	} subinfo;
+extern void sysinfo_init(void);
 
-	struct sysinfo_item *next;
-	int val_type;
-	int subinfo_type;
-} sysinfo_item_t;
+extern void sysinfo_set_item_val(const char *, sysinfo_item_t **, unative_t);
+extern void sysinfo_set_item_data(const char *, sysinfo_item_t **, void *,
+    size_t);
+extern void sysinfo_set_item_val_fn(const char *, sysinfo_item_t **,
+    sysinfo_fn_val_t);
+extern void sysinfo_set_item_data_fn(const char *, sysinfo_item_t **,
+    sysinfo_fn_data_t);
+extern void sysinfo_set_item_undefined(const char *, sysinfo_item_t **);
 
-#define SYSINFO_VAL_VAL        0
-#define SYSINFO_VAL_FUNCTION   1
-#define SYSINFO_VAL_UNDEFINED  U_SPECIAL
+extern sysinfo_return_t sysinfo_get_item(const char *, sysinfo_item_t **);
+extern void sysinfo_dump(sysinfo_item_t **, unsigned int);
 
-#define SYSINFO_SUBINFO_NONE      0
-#define SYSINFO_SUBINFO_TABLE     1
-#define SYSINFO_SUBINFO_FUNCTION  2
-
-typedef unative_t (*sysinfo_val_fn_t)(sysinfo_item_t *root);
-typedef unative_t (*sysinfo_subinfo_fn_t)(const char *subname);
-
-typedef struct sysinfo_rettype {
-	unative_t val;
-	unative_t valid;
-} sysinfo_rettype_t;
-
-void sysinfo_set_item_val(const char *name, sysinfo_item_t **root, unative_t val);
-void sysinfo_dump(sysinfo_item_t **root, int depth);
-void sysinfo_set_item_function(const char *name, sysinfo_item_t **root, sysinfo_val_fn_t fn);
-void sysinfo_set_item_undefined(const char *name, sysinfo_item_t **root);
-
-sysinfo_rettype_t sysinfo_get_val(const char *name, sysinfo_item_t **root);
-
-unative_t sys_sysinfo_valid(unative_t ptr, unative_t len);
-unative_t sys_sysinfo_value(unative_t ptr, unative_t len);
+unative_t sys_sysinfo_get_tag(void *, size_t);
+unative_t sys_sysinfo_get_value(void *, size_t, void *);
+unative_t sys_sysinfo_get_data_size(void *, size_t, void *);
+unative_t sys_sysinfo_get_data(void *, size_t, void *, size_t);
 
 #endif
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/console/cmd.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -66,4 +66,5 @@
 #include <ipc/irq.h>
 #include <ipc/event.h>
+#include <sysinfo/sysinfo.h>
 #include <symtab.h>
 #include <errno.h>
@@ -387,4 +388,12 @@
 };
 
+static int cmd_sysinfo(cmd_arg_t *argv);
+static cmd_info_t sysinfo_info = {
+	.name = "sysinfo",
+	.description = "Dump sysinfo.",
+	.func = cmd_sysinfo,
+	.argc = 0
+};
+
 /* Data and methods for 'zones' command */
 static int cmd_zones(cmd_arg_t *argv);
@@ -475,4 +484,5 @@
 	&set4_info,
 	&slabs_info,
+	&sysinfo_info,
 	&symaddr_info,
 	&sched_info,
@@ -868,4 +878,16 @@
 }
 
+/** Command for dumping sysinfo
+ *
+ * @param argv Ignores
+ *
+ * @return Always 1
+ */
+int cmd_sysinfo(cmd_arg_t * argv)
+{
+	sysinfo_dump(NULL, 0);
+	return 1;
+}
+
 
 /** Command for listings Thread information
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/ipc/sysipc.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -58,10 +58,17 @@
 #define DATA_XFER_LIMIT		(64 * 1024)
 
-#define GET_CHECK_PHONE(phone, phoneid, err) \
-{ \
-	if (phoneid > IPC_MAX_PHONES) { \
-		err \
-	} \
-	phone = &TASK->phones[phoneid]; \
+/** Get phone from the current task by ID.
+ *
+ * @param phoneid	Phone ID.
+ * @param phone		Place to store pointer to phone.
+ * @return		EOK on success, EINVAL if ID is invalid.
+ */
+static int phone_get(unative_t phoneid, phone_t **phone)
+{
+	if (phoneid >= IPC_MAX_PHONES)
+		return EINVAL;
+
+	*phone = &TASK->phones[phoneid];
+	return EOK;
 }
 
@@ -374,7 +381,9 @@
 	case IPC_M_CONNECTION_CLONE: {
 		phone_t *cloned_phone;
-		GET_CHECK_PHONE(cloned_phone, IPC_GET_ARG1(call->data),
-		    return ENOENT;);
+
+		if (phone_get(IPC_GET_ARG1(call->data), &cloned_phone) != EOK)
+			return ENOENT;
 		phones_lock(cloned_phone, phone);
+
 		if ((cloned_phone->state != IPC_PHONE_CONNECTED) ||
 		    phone->state != IPC_PHONE_CONNECTED) {
@@ -534,6 +543,7 @@
 	int res;
 	int rc;
-	
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
+
+	if (phone_get(phoneid, &phone) != EOK)
+		return ENOENT;
 
 	call = ipc_call_alloc(0);
@@ -591,5 +601,6 @@
 	int rc;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
+	if (phone_get(phoneid, &phone) != EOK)
+		return ENOENT;
 
 	call = ipc_call_alloc(0);
@@ -666,5 +677,6 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	if (phone_get(phoneid, &phone) != EOK)
+		return IPC_CALLRET_FATAL;
 
 	call = ipc_call_alloc(0);
@@ -705,5 +717,6 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	if (phone_get(phoneid, &phone) != EOK)
+		return IPC_CALLRET_FATAL;
 
 	call = ipc_call_alloc(0);
@@ -755,9 +768,9 @@
 	call->flags |= IPC_CALL_FORWARDED;
 
-	GET_CHECK_PHONE(phone, phoneid, {
+	if (phone_get(phoneid, &phone) != EOK) {
 		IPC_SET_RETVAL(call->data, EFORWARD);
 		ipc_answer(&TASK->answerbox, call);
 		return ENOENT;
-	});
+	}
 
 	if (!method_is_forwardable(IPC_GET_METHOD(call->data))) {
@@ -956,9 +969,10 @@
  * @return		Return 0 on success or an error code.
  */
-unative_t sys_ipc_hangup(int phoneid)
+unative_t sys_ipc_hangup(unative_t phoneid)
 {
 	phone_t *phone;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
+	if (phone_get(phoneid, &phone) != EOK)
+		return ENOENT;
 
 	if (ipc_phone_hangup(phone))
Index: kernel/generic/src/lib/str.c
===================================================================
--- kernel/generic/src/lib/str.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/lib/str.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -537,25 +537,23 @@
  * null-terminated and containing only complete characters.
  *
- * @param dest   Destination buffer.
+ * @param dest  Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
+ *
  */
 void str_cpy(char *dest, size_t size, const char *src)
 {
-	wchar_t ch;
-	size_t src_off;
-	size_t dest_off;
-
 	/* There must be space for a null terminator in the buffer. */
 	ASSERT(size > 0);
 	
-	src_off = 0;
-	dest_off = 0;
-
+	size_t src_off = 0;
+	size_t dest_off = 0;
+	
+	wchar_t ch;
 	while ((ch = str_decode(src, &src_off, STR_NO_LIMIT)) != 0) {
 		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
 			break;
 	}
-
+	
 	dest[dest_off] = '\0';
 }
@@ -571,27 +569,84 @@
  * have to be null-terminated.
  *
- * @param dest   Destination buffer.
+ * @param dest  Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
- * @param n	Maximum number of bytes to read from @a src.
+ * @param n     Maximum number of bytes to read from @a src.
+ *
  */
 void str_ncpy(char *dest, size_t size, const char *src, size_t n)
 {
-	wchar_t ch;
-	size_t src_off;
-	size_t dest_off;
-
 	/* There must be space for a null terminator in the buffer. */
 	ASSERT(size > 0);
 	
-	src_off = 0;
-	dest_off = 0;
-
+	size_t src_off = 0;
+	size_t dest_off = 0;
+	
+	wchar_t ch;
 	while ((ch = str_decode(src, &src_off, n)) != 0) {
 		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
 			break;
 	}
-
+	
 	dest[dest_off] = '\0';
+}
+
+/** Duplicate string.
+ *
+ * Allocate a new string and copy characters from the source
+ * string into it. The duplicate string is allocated via sleeping
+ * malloc(), thus this function can sleep in no memory conditions.
+ *
+ * The allocation cannot fail and the return value is always
+ * a valid pointer. The duplicate string is always a well-formed
+ * null-terminated UTF-8 string, but it can differ from the source
+ * string on the byte level.
+ *
+ * @param src Source string.
+ *
+ * @return Duplicate string.
+ *
+ */
+char *str_dup(const char *src)
+{
+	size_t size = str_size(src) + 1;
+	char *dest = malloc(size, 0);
+	ASSERT(dest);
+	
+	str_cpy(dest, size, src);
+	return dest;
+}
+
+/** Duplicate string with size limit.
+ *
+ * Allocate a new string and copy up to @max_size bytes from the source
+ * string into it. The duplicate string is allocated via sleeping
+ * malloc(), thus this function can sleep in no memory conditions.
+ * No more than @max_size + 1 bytes is allocated, but if the size
+ * occupied by the source string is smaller than @max_size + 1,
+ * less is allocated.
+ *
+ * The allocation cannot fail and the return value is always
+ * a valid pointer. The duplicate string is always a well-formed
+ * null-terminated UTF-8 string, but it can differ from the source
+ * string on the byte level.
+ *
+ * @param src Source string.
+ * @param n   Maximum number of bytes to duplicate.
+ *
+ * @return Duplicate string.
+ *
+ */
+char *str_ndup(const char *src, size_t n)
+{
+	size_t size = str_size(src);
+	if (size > n)
+		size = n;
+	
+	char *dest = malloc(size + 1, 0);
+	ASSERT(dest);
+	
+	str_ncpy(dest, size + 1, src, size);
+	return dest;
 }
 
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/main/main.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -84,4 +84,5 @@
 #include <main/main.h>
 #include <ipc/event.h>
+#include <sysinfo/sysinfo.h>
 
 /** Global configuration structure. */
@@ -209,4 +210,5 @@
 	/* Initialize at least 1 memory segment big enough for slab to work. */
 	LOG_EXEC(slab_cache_init());
+	LOG_EXEC(sysinfo_init());
 	LOG_EXEC(btree_init());
 	LOG_EXEC(as_init());
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/proc/task.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -33,5 +33,5 @@
 /**
  * @file
- * @brief	Task management.
+ * @brief Task management.
  */
 
@@ -66,4 +66,5 @@
  * The task is guaranteed to exist after it was found in the tasks_tree as
  * long as:
+ *
  * @li the tasks_lock is held,
  * @li the task's lock is held when task's lock is acquired before releasing
@@ -99,5 +100,5 @@
 	task_t *t = avltree_get_instance(node, task_t, tasks_tree_node);
 	unsigned *cnt = (unsigned *) arg;
-
+	
 	if (t != TASK) {
 		(*cnt)++;
@@ -107,6 +108,7 @@
 		task_kill_internal(t);
 	}
-
-	return true;	/* continue the walk */
+	
+	/* Continue the walk */
+	return true;
 }
 
@@ -115,5 +117,5 @@
 {
 	unsigned tasks_left;
-
+	
 	do { /* Repeat until there are any tasks except TASK */
 		/* Messing with task structures, avoid deadlock */
@@ -138,19 +140,19 @@
 	task_t *ta = obj;
 	int i;
-
+	
 	atomic_set(&ta->refcount, 0);
 	atomic_set(&ta->lifecount, 0);
 	atomic_set(&ta->active_calls, 0);
-
+	
 	spinlock_initialize(&ta->lock, "task_ta_lock");
 	mutex_initialize(&ta->futexes_lock, MUTEX_PASSIVE);
-
+	
 	list_initialize(&ta->th_head);
 	list_initialize(&ta->sync_box_head);
-
+	
 	ipc_answerbox_init(&ta->answerbox, ta);
 	for (i = 0; i < IPC_MAX_PHONES; i++)
 		ipc_phone_init(&ta->phones[i]);
-
+	
 #ifdef CONFIG_UDEBUG
 	/* Init kbox stuff */
@@ -159,5 +161,5 @@
 	mutex_initialize(&ta->kb.cleanup_lock, MUTEX_PASSIVE);
 #endif
-
+	
 	return 0;
 }
@@ -165,8 +167,8 @@
 /** Create new task with no threads.
  *
- * @param as		Task's address space.
- * @param name		Symbolic name (a copy is made).
- *
- * @return		New task's structure.
+ * @param as   Task's address space.
+ * @param name Symbolic name (a copy is made).
+ *
+ * @return New task's structure.
  *
  */
@@ -181,5 +183,5 @@
 	memcpy(ta->name, name, TASK_NAME_BUFLEN);
 	ta->name[TASK_NAME_BUFLEN - 1] = 0;
-
+	
 	ta->context = CONTEXT;
 	ta->capabilities = 0;
@@ -197,13 +199,13 @@
 	/* Init debugging stuff */
 	udebug_task_init(&ta->udebug);
-
+	
 	/* Init kbox stuff */
 	ta->kb.finished = false;
 #endif
-
+	
 	if ((ipc_phone_0) &&
 	    (context_check(ipc_phone_0->task->context, ta->context)))
 		ipc_phone_connect(&ta->phones[0], ipc_phone_0);
-
+	
 	btree_create(&ta->futexes);
 	
@@ -223,5 +225,6 @@
 /** Destroy task.
  *
- * @param t		Task to be destroyed.
+ * @param t Task to be destroyed.
+ *
  */
 void task_destroy(task_t *t)
@@ -233,15 +236,15 @@
 	avltree_delete(&tasks_tree, &t->tasks_tree_node);
 	spinlock_unlock(&tasks_lock);
-
+	
 	/*
 	 * Perform architecture specific task destruction.
 	 */
 	task_destroy_arch(t);
-
+	
 	/*
 	 * Free up dynamically allocated state.
 	 */
 	btree_destroy(&t->futexes);
-
+	
 	/*
 	 * Drop our reference to the address space.
@@ -256,8 +259,9 @@
 /** Syscall for reading task ID from userspace.
  *
- * @param		uspace_task_id userspace address of 8-byte buffer
- * 			where to store current task ID.
- *
- * @return		Zero on success or an error code from @ref errno.h.
+ * @param uspace_task_id Userspace address of 8-byte buffer
+ *                       where to store current task ID.
+ *
+ * @return Zero on success or an error code from @ref errno.h.
+ *
  */
 unative_t sys_task_get_id(task_id_t *uspace_task_id)
@@ -275,8 +279,9 @@
  * The name simplifies identifying the task in the task list.
  *
- * @param name	The new name for the task. (typically the same
- *		as the command used to execute it).
+ * @param name The new name for the task. (typically the same
+ *             as the command used to execute it).
  *
  * @return 0 on success or an error code from @ref errno.h.
+ *
  */
 unative_t sys_task_set_name(const char *uspace_name, size_t name_len)
@@ -284,17 +289,17 @@
 	int rc;
 	char namebuf[TASK_NAME_BUFLEN];
-
+	
 	/* Cap length of name and copy it from userspace. */
-
+	
 	if (name_len > TASK_NAME_BUFLEN - 1)
 		name_len = TASK_NAME_BUFLEN - 1;
-
+	
 	rc = copy_from_uspace(namebuf, uspace_name, name_len);
 	if (rc != 0)
 		return (unative_t) rc;
-
+	
 	namebuf[name_len] = '\0';
 	str_cpy(TASK->name, TASK_NAME_BUFLEN, namebuf);
-
+	
 	return EOK;
 }
@@ -305,15 +310,18 @@
  * interrupts must be disabled.
  *
- * @param id		Task ID.
- *
- * @return		Task structure address or NULL if there is no such task
- * 			ID.
- */
-task_t *task_find_by_id(task_id_t id) { avltree_node_t *node;
-	
+ * @param id Task ID.
+ *
+ * @return Task structure address or NULL if there is no such task
+ *         ID.
+ *
+ */
+task_t *task_find_by_id(task_id_t id)
+{
+	avltree_node_t *node;
 	node = avltree_search(&tasks_tree, (avltree_key_t) id);
-
+	
 	if (node)
 		return avltree_get_instance(node, task_t, tasks_tree_node); 
+	
 	return NULL;
 }
@@ -324,7 +332,8 @@
  * already disabled.
  *
- * @param t		Pointer to thread.
- * @param ucycles	Out pointer to sum of all user cycles.
- * @param kcycles	Out pointer to sum of all kernel cycles.
+ * @param t       Pointer to thread.
+ * @param ucycles Out pointer to sum of all user cycles.
+ * @param kcycles Out pointer to sum of all kernel cycles.
+ *
  */
 void task_get_accounting(task_t *t, uint64_t *ucycles, uint64_t *kcycles)
@@ -359,5 +368,5 @@
 {
 	link_t *cur;
-
+	
 	/*
 	 * Interrupt all threads.
@@ -387,7 +396,8 @@
  * It signals all the task's threads to bail it out.
  *
- * @param id		ID of the task to be killed.
- *
- * @return		Zero on success or an error code from errno.h.
+ * @param id ID of the task to be killed.
+ *
+ * @return Zero on success or an error code from errno.h.
+ *
  */
 int task_kill(task_id_t id)
@@ -416,7 +426,7 @@
 	task_t *t = avltree_get_instance(node, task_t, tasks_tree_node);
 	int j;
-		
+	
 	spinlock_lock(&t->lock);
-			
+	
 	uint64_t ucycles;
 	uint64_t kcycles;
@@ -425,5 +435,5 @@
 	order(ucycles, &ucycles, &usuffix);
 	order(kcycles, &kcycles, &ksuffix);
-
+	
 #ifdef __32_BITS__	
 	printf("%-6" PRIu64 " %-12s %-3" PRIu32 " %10p %10p %9" PRIu64 "%c %9"
@@ -432,5 +442,5 @@
 		atomic_get(&t->active_calls));
 #endif
-
+	
 #ifdef __64_BITS__
 	printf("%-6" PRIu64 " %-12s %-3" PRIu32 " %18p %18p %9" PRIu64 "%c %9"
@@ -439,5 +449,5 @@
 		atomic_get(&t->active_calls));
 #endif
-
+	
 	for (j = 0; j < IPC_MAX_PHONES; j++) {
 		if (t->phones[j].callee)
@@ -445,5 +455,5 @@
 	}
 	printf("\n");
-			
+	
 	spinlock_unlock(&t->lock);
 	return true;
@@ -458,6 +468,6 @@
 	ipl = interrupts_disable();
 	spinlock_lock(&tasks_lock);
-
-#ifdef __32_BITS__	
+	
+#ifdef __32_BITS__
 	printf("taskid name         ctx address    as        "
 	    " ucycles    kcycles    threads calls  callee\n");
@@ -465,5 +475,5 @@
 	    " ---------- ---------- ------- ------ ------>\n");
 #endif
-
+	
 #ifdef __64_BITS__
 	printf("taskid name         ctx address            as                "
@@ -472,7 +482,7 @@
 	    " ---------- ---------- ---------- ------- ------ ------>\n");
 #endif
-
+	
 	avltree_walk(&tasks_tree, task_print_walker, NULL);
-
+	
 	spinlock_unlock(&tasks_lock);
 	interrupts_restore(ipl);
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ kernel/generic/src/syscall/syscall.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -162,6 +162,8 @@
 	
 	/* Sysinfo syscalls */
-	(syshandler_t) sys_sysinfo_valid,
-	(syshandler_t) sys_sysinfo_value,
+	(syshandler_t) sys_sysinfo_get_tag,
+	(syshandler_t) sys_sysinfo_get_value,
+	(syshandler_t) sys_sysinfo_get_data_size,
+	(syshandler_t) sys_sysinfo_get_data,
 	
 	/* Debug calls */
